#ifndef EVENT_DISPLAY_CREATOR_H
#define EVENT_DISPLAY_CREATOR_H


/**
 * 	The EVENT_DISPLAY_CREATOR is a class that allows to instantiate an
 * 	EVENT_DISPLAY_CREATOR object ina any processor this is able to 
 * 	create an event display	of any marlinTPC event.
 * 	This tool makes use of Root
 * 
 * 	Input is a LCCollection of Tracks so far
 * 	will be enhanced to create also displays for data and maybe hits
 * 
 * 
 * 	@author Christoph Brezina, University of Bonn (Based on work of F.Mueller)
 **/

//LCIO
#include <lcio.h>
#include <EVENT/Track.h>
#include <IMPL/LCCollectionVec.h>
#include <EVENT/TrackerHit.h>
#include <EVENT/TrackerData.h>
#include <marlin/Exceptions.h>

// #include <EVENT/LCEvent.h>
// #include <EVENT/LCCollection.h>
// #include <IMPL/LCRelationImpl.h>
// #include "UTIL/LCTOOLS.h"
// #include "UTIL/LCRelationNavigator.h"
// #include <IMPL/LCFlagImpl.h>

// root
#include "TH2F.h"
#include "TF1.h"
#include "TList.h"

// C++
#include <iostream>
#include <string>
#include <sstream>
#include <cmath>



namespace marlintpc
{
  class TimePixEventDisplayCreator
  {  
    public:
      TimePixEventDisplayCreator();
      TimePixEventDisplayCreator(double inXMin, double inXMax, double inYMin, double inYMax, double inZMin, double inZMax, int InXPixel, int InYPixel);
      ~TimePixEventDisplayCreator();
      TH2F *GetTH2F_TracksXY(IMPL::LCCollectionVec* inputColVec, unsigned int EventNr, unsigned int RunNr, unsigned int showcharge);
      TH2F *GetTH2F_TracksZX(IMPL::LCCollectionVec* inputColVec, unsigned int EventNr, unsigned int RunNr);
      TH2F *GetTH2F_TracksZY(IMPL::LCCollectionVec* inputColVec, unsigned int EventNr, unsigned int RunNr);
      
    //protected:
      
    private:
     double _xMin, _xMax, _yMin, _yMax, _zMin, _zMax;
     unsigned int _xPixel, _yPixel;
      
  };
  
  
} // end namespace marlintpc


#endif // EVENT_DISPLAY_CREATOR_H
