#include "SimpleMinimizerResidualsFunction.h"

namespace marlintpc
{
SimpleMinimizerResidualsFunction::SimpleMinimizerResidualsFunction(const EVENT::Track * const t, TrackFitterBase const * f) :
        track(t) , fitter(f), theErrorDef(1.)
{}

double SimpleMinimizerResidualsFunction::operator()(const std::vector<double>&trackParams) const
{
    double chiSquare = 0;
    IMPL::TrackImpl trackWithTestParameters;
    trackWithTestParameters.setD0(trackParams[0]);
    trackWithTestParameters.setPhi(trackParams[1]);
    trackWithTestParameters.setTanLambda(trackParams[2]);
    trackWithTestParameters.setZ0(trackParams[3]);
    trackWithTestParameters.setOmega(trackParams[4]);

    for (TrackerHitVec::const_iterator hitIter = track->getTrackerHits().begin() ;
            hitIter < track->getTrackerHits().end() ; hitIter++)
        {
            EVENT::DoubleVec residuals = fitter->calculateResiduals(*hitIter, &trackWithTestParameters);

            // FIXME: calculate real chiSquare taking into account the errors
            chiSquare += residuals[0] * residuals[0] + residuals[1] * residuals[1];
        }

    return chiSquare;
}


}//namespace marlintpc
