/*
 * AltroConverterGlobals.hh
 *
 *  Created on: Jul 9, 2012
 *      Author: caiazza
 */

#ifndef ALTROCONVERTERGLOBALS_HH_
#define ALTROCONVERTERGLOBALS_HH_

#include <fstream>

namespace marlintpc
{

const uint32_t WORD32 = 4;
const uint16_t WORD16 = 2;

inline uint32_t
ReadWord32(std::ifstream* inputFile)
{
    char tmp[WORD32];
    inputFile->read(tmp, WORD32);
    return static_cast<uint32_t>(static_cast<unsigned char>(tmp[0]))
            | static_cast<uint32_t>(static_cast<unsigned char>(tmp[1])) << 8
            | static_cast<uint32_t>(static_cast<unsigned char>(tmp[2])) << 16
            | static_cast<uint32_t>(static_cast<unsigned char>(tmp[3])) << 24;
}

inline uint16_t
ReadWord16(std::ifstream* inputFile)
{
    char tmp[WORD16];
    inputFile->read(tmp, WORD16);
    return static_cast<uint16_t>(static_cast<unsigned char>(tmp[0]))
            | static_cast<uint16_t>(static_cast<unsigned char>(tmp[1])) << 8;
}

inline uint32_t
InvertWord32(uint32_t &value)
{
    return (value & 0xff000000) | (value & 0x00ff0000) << 8 | (value & 0x0000ff00) << 16
            | (value & 0x000000ff) << 24;
}


enum BlockID
{
    BLOCK_SOR = 0x11111111,
    BLOCK_EOR = 0x33333333,
    BLOCK_POR = 0x11112222,
    BLOCK_COR = 0x11113333,
    BLOCK_EVENT = 0x22222222,
    BLOCK_BOF = 0x44444444,
    BLOCK_EOF = 0x55555555,
    BLOCK_RCU = 0xFFFFFFFF
};

}


#endif /* ALTROCONVERTERGLOBALS_HH_ */
