#!/bin/bash
echo MARLINTPC_SOURCE_DIR is ${MARLINTPC_SOURCE_DIR}
echo MARLINTPC_BIN_DIR is ${MARLINTPC_BIN_DIR}
echo MARLIN_DLL is ${MARLIN_DLL}

echo Marlin is ${MARLIN_BIN_DIR}/Marlin

TEST_DIRECTORY=test_generatePedestalRawData

mkdir ${TEST_DIRECTORY}
cd ${TEST_DIRECTORY} 

#execute 
${MARLINTPC_BIN_DIR}/generatePedestalRawData
if [ $? -ne 0 ]; then
    echo generatePedestalRawData did not succeed
    exit 1
fi

${MARLIN_BIN_DIR}/Marlin ${MARLINTPC_SOURCE_DIR}/validation/testConditions/pedestal_calculation.xml
if [ $? -ne 0 ]; then
    echo Marlin pedestal_calculation.xml did not succeed
fi


${MARLINTPC_BIN_DIR}/checkCalculatedPedestals
if [ $? -ne 0 ]; then
    echo checkCalculatedPedestals did not succeed
fi

#only clean up if there was no error, otherwise leave the directory for debugging
cd ..
rm -rf  ${TEST_DIRECTORY}

exit 0
